git main documentation: point at the user's manual.
[git/gitweb.git] / git-clone.sh
blob4ddfa774ecf70d00b16157d5fc29bfe561702e87
1 #!/bin/sh
3 # Copyright (c) 2005, Linus Torvalds
4 # Copyright (c) 2005, Junio C Hamano
5 #
6 # Clone a repository into a different directory that does not yet exist.
8 # See git-sh-setup why.
9 unset CDPATH
11 die() {
12 echo >&2 "$@"
13 exit 1
16 usage() {
17 die "Usage: $0 [--template=<template_directory>] [--reference <reference-repo>] [--bare] [-l [-s]] [-q] [-u <upload-pack>] [--origin <name>] [--depth <n>] [-n] <repo> [<dir>]"
20 get_repo_base() {
21 (cd "$1" && (cd .git ; pwd)) 2> /dev/null
24 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
25 curl_extra_args="-k"
28 http_fetch () {
29 # $1 = Remote, $2 = Local
30 curl -nsfL $curl_extra_args "$1" >"$2"
33 clone_dumb_http () {
34 # $1 - remote, $2 - local
35 cd "$2" &&
36 clone_tmp="$GIT_DIR/clone-tmp" &&
37 mkdir -p "$clone_tmp" || exit 1
38 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
39 "`git-config --bool http.noEPSV`" = true ]; then
40 curl_extra_args="${curl_extra_args} --disable-epsv"
42 http_fetch "$1/info/refs" "$clone_tmp/refs" ||
43 die "Cannot get remote repository information.
44 Perhaps git-update-server-info needs to be run there?"
45 while read sha1 refname
47 name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
48 case "$name" in
49 *^*) continue;;
50 esac
51 case "$bare,$name" in
52 yes,* | ,heads/* | ,tags/*) ;;
53 *) continue ;;
54 esac
55 if test -n "$use_separate_remote" &&
56 branch_name=`expr "z$name" : 'zheads/\(.*\)'`
57 then
58 tname="remotes/$origin/$branch_name"
59 else
60 tname=$name
62 git-http-fetch -v -a -w "$tname" "$name" "$1/" || exit 1
63 done <"$clone_tmp/refs"
64 rm -fr "$clone_tmp"
65 http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
66 rm -f "$GIT_DIR/REMOTE_HEAD"
69 quiet=
70 local=no
71 use_local=no
72 local_shared=no
73 unset template
74 no_checkout=
75 upload_pack=
76 bare=
77 reference=
78 origin=
79 origin_override=
80 use_separate_remote=t
81 depth=
82 while
83 case "$#,$1" in
84 0,*) break ;;
85 *,-n|*,--no|*,--no-|*,--no-c|*,--no-ch|*,--no-che|*,--no-chec|\
86 *,--no-check|*,--no-checko|*,--no-checkou|*,--no-checkout)
87 no_checkout=yes ;;
88 *,--na|*,--nak|*,--nake|*,--naked|\
89 *,-b|*,--b|*,--ba|*,--bar|*,--bare) bare=yes ;;
90 *,-l|*,--l|*,--lo|*,--loc|*,--loca|*,--local) use_local=yes ;;
91 *,-s|*,--s|*,--sh|*,--sha|*,--shar|*,--share|*,--shared)
92 local_shared=yes; use_local=yes ;;
93 1,--template) usage ;;
94 *,--template)
95 shift; template="--template=$1" ;;
96 *,--template=*)
97 template="$1" ;;
98 *,-q|*,--quiet) quiet=-q ;;
99 *,--use-separate-remote) ;;
100 *,--no-separate-remote)
101 die "clones are always made with separate-remote layout" ;;
102 1,--reference) usage ;;
103 *,--reference)
104 shift; reference="$1" ;;
105 *,--reference=*)
106 reference=`expr "z$1" : 'z--reference=\(.*\)'` ;;
107 *,-o|*,--or|*,--ori|*,--orig|*,--origi|*,--origin)
108 case "$2" in
110 usage ;;
111 */*)
112 die "'$2' is not suitable for an origin name"
113 esac
114 git-check-ref-format "heads/$2" ||
115 die "'$2' is not suitable for a branch name"
116 test -z "$origin_override" ||
117 die "Do not give more than one --origin options."
118 origin_override=yes
119 origin="$2"; shift
121 1,-u|1,--upload-pack) usage ;;
122 *,-u|*,--upload-pack)
123 shift
124 upload_pack="--upload-pack=$1" ;;
125 *,--upload-pack=*)
126 upload_pack=--upload-pack=$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
127 1,--depth) usage;;
128 *,--depth)
129 shift
130 depth="--depth=$1";;
131 *,-*) usage ;;
132 *) break ;;
133 esac
135 shift
136 done
138 repo="$1"
139 test -n "$repo" ||
140 die 'you must specify a repository to clone.'
142 # --bare implies --no-checkout and --no-separate-remote
143 if test yes = "$bare"
144 then
145 if test yes = "$origin_override"
146 then
147 die '--bare and --origin $origin options are incompatible.'
149 no_checkout=yes
150 use_separate_remote=
153 if test -z "$origin"
154 then
155 origin=origin
158 # Turn the source into an absolute path if
159 # it is local
160 if base=$(get_repo_base "$repo"); then
161 repo="$base"
162 local=yes
165 dir="$2"
166 # Try using "humanish" part of source repo if user didn't specify one
167 [ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
168 [ -e "$dir" ] && die "destination directory '$dir' already exists."
169 mkdir -p "$dir" &&
170 D=$(cd "$dir" && pwd) &&
171 trap 'err=$?; cd ..; rm -rf "$D"; exit $err' 0
172 case "$bare" in
173 yes)
174 GIT_DIR="$D" ;;
176 GIT_DIR="$D/.git" ;;
177 esac && export GIT_DIR && git-init ${template+"$template"} || usage
179 if test -n "$reference"
180 then
181 if test -d "$reference"
182 then
183 if test -d "$reference/.git/objects"
184 then
185 reference="$reference/.git"
187 reference=$(cd "$reference" && pwd)
188 echo "$reference/objects" >"$GIT_DIR/objects/info/alternates"
189 (cd "$reference" && tar cf - refs) |
190 (cd "$GIT_DIR/refs" &&
191 mkdir reference-tmp &&
192 cd reference-tmp &&
193 tar xf -)
194 else
195 die "reference repository '$reference' is not a local directory."
199 rm -f "$GIT_DIR/CLONE_HEAD"
201 # We do local magic only when the user tells us to.
202 case "$local,$use_local" in
203 yes,yes)
204 ( cd "$repo/objects" ) ||
205 die "-l flag seen but repository '$repo' is not local."
207 case "$local_shared" in
209 # See if we can hardlink and drop "l" if not.
210 sample_file=$(cd "$repo" && \
211 find objects -type f -print | sed -e 1q)
213 # objects directory should not be empty since we are cloning!
214 test -f "$repo/$sample_file" || exit
217 if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
218 then
220 fi &&
221 rm -f "$GIT_DIR/objects/sample" &&
222 cd "$repo" &&
223 find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
225 yes)
226 mkdir -p "$GIT_DIR/objects/info"
227 echo "$repo/objects" >> "$GIT_DIR/objects/info/alternates"
229 esac
230 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
233 case "$repo" in
234 rsync://*)
235 case "$depth" in
236 "") ;;
237 *) die "shallow over rsync not supported" ;;
238 esac
239 rsync $quiet -av --ignore-existing \
240 --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
241 exit
242 # Look at objects/info/alternates for rsync -- http will
243 # support it natively and git native ones will do it on the
244 # remote end. Not having that file is not a crime.
245 rsync -q "$repo/objects/info/alternates" \
246 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
247 rm -f "$GIT_DIR/TMP_ALT"
248 if test -f "$GIT_DIR/TMP_ALT"
249 then
250 ( cd "$D" &&
251 . git-parse-remote &&
252 resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
253 while read alt
255 case "$alt" in 'bad alternate: '*) die "$alt";; esac
256 case "$quiet" in
257 '') echo >&2 "Getting alternate: $alt" ;;
258 esac
259 rsync $quiet -av --ignore-existing \
260 --exclude info "$alt" "$GIT_DIR/objects" || exit
261 done
262 rm -f "$GIT_DIR/TMP_ALT"
264 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
266 https://*|http://*|ftp://*)
267 case "$depth" in
268 "") ;;
269 *) die "shallow over http or ftp not supported" ;;
270 esac
271 if test -z "@@NO_CURL@@"
272 then
273 clone_dumb_http "$repo" "$D"
274 else
275 die "http transport not supported, rebuild Git with curl support"
279 case "$upload_pack" in
280 '') git-fetch-pack --all -k $quiet $depth "$repo" ;;
281 *) git-fetch-pack --all -k $quiet "$upload_pack" $depth "$repo" ;;
282 esac >"$GIT_DIR/CLONE_HEAD" ||
283 die "fetch-pack from '$repo' failed."
285 esac
287 esac
288 test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
290 if test -f "$GIT_DIR/CLONE_HEAD"
291 then
292 # Read git-fetch-pack -k output and store the remote branches.
293 if [ -n "$use_separate_remote" ]
294 then
295 branch_top="remotes/$origin"
296 else
297 branch_top="heads"
299 tag_top="tags"
300 while read sha1 name
302 case "$name" in
303 *'^{}')
304 continue ;;
305 HEAD)
306 destname="REMOTE_HEAD" ;;
307 refs/heads/*)
308 destname="refs/$branch_top/${name#refs/heads/}" ;;
309 refs/tags/*)
310 destname="refs/$tag_top/${name#refs/tags/}" ;;
312 continue ;;
313 esac
314 git-update-ref -m "clone: from $repo" "$destname" "$sha1" ""
315 done < "$GIT_DIR/CLONE_HEAD"
318 cd "$D" || exit
320 if test -z "$bare" && test -f "$GIT_DIR/REMOTE_HEAD"
321 then
322 # a non-bare repository is always in separate-remote layout
323 remote_top="refs/remotes/$origin"
324 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
325 case "$head_sha1" in
326 'ref: refs/'*)
327 # Uh-oh, the remote told us (http transport done against
328 # new style repository with a symref HEAD).
329 # Ideally we should skip the guesswork but for now
330 # opt for minimum change.
331 head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
332 head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
334 esac
336 # The name under $remote_top the remote HEAD seems to point at.
337 head_points_at=$(
339 test -f "$GIT_DIR/$remote_top/master" && echo "master"
340 cd "$GIT_DIR/$remote_top" &&
341 find . -type f -print | sed -e 's/^\.\///'
342 ) | (
343 done=f
344 while read name
346 test t = $done && continue
347 branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
348 if test "$head_sha1" = "$branch_tip"
349 then
350 echo "$name"
351 done=t
353 done
357 # Write out remote.$origin config, and update our "$head_points_at".
358 case "$head_points_at" in
360 # Local default branch
361 git-symbolic-ref HEAD "refs/heads/$head_points_at" &&
363 # Tracking branch for the primary branch at the remote.
364 origin_track="$remote_top/$head_points_at" &&
365 git-update-ref HEAD "$head_sha1" &&
367 # Upstream URL
368 git-config remote."$origin".url "$repo" &&
370 # Set up the mappings to track the remote branches.
371 git-config remote."$origin".fetch \
372 "+refs/heads/*:$remote_top/*" '^$' &&
373 rm -f "refs/remotes/$origin/HEAD"
374 git-symbolic-ref "refs/remotes/$origin/HEAD" \
375 "refs/remotes/$origin/$head_points_at" &&
377 git-config branch."$head_points_at".remote "$origin" &&
378 git-config branch."$head_points_at".merge "refs/heads/$head_points_at"
379 esac
381 case "$no_checkout" in
383 test "z$quiet" = z && v=-v || v=
384 git-read-tree -m -u $v HEAD HEAD
385 esac
387 rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"
389 trap - 0